<template>
    <label :for="'textarea-'+name" class="bbox-textarea-label" :class="{'has-error': !!error}">
        <span :class="[labelClassesToApply,'label']" v-if="!$slots.label && !!label">{{ label }}</span>
        <slot name="label"/>
        <div class="textarea-wrapper">
            <span class="icon-left" v-if="$slots['icon-left']"><slot name="icon-left"/></span>
            <span class="icon-right" v-if="$slots['icon-right']"><slot name="icon-right"/></span>
            <textarea :maxlength='maxlength' ref="textarea" class="bbox-textarea" :class="[textareaClassesToApply,{'has-icon-left': !!$slots['icon-left'], 'has-icon-right': !!$slots['icon-right']}]" :id="'textarea-'+name" :value="value" :name="name" @input="($event) => {$emit('input', $event.target.value)}" :placeholder="placeholder"/>
        </div>
        <span class="input-error font-size-big red-base margin-top-tiny" v-if="!!error"><b-icon><icon-error-outline/></b-icon> {{ error }}</span>
    </label>
</template>

<script>
import BIcon from './Icon.vue';

export default {
    name: 'b-textarea',
    components: {
        BIcon
    },
    props: {
        textareaClasses: {
          type: String,
          default: "font-size-big ink-base placeholder-ink-lighter-2 padding-normal border border-white-darker-4 border-focus-ink-lighter-1  bg-white-darker-2 bg-focus-white-darker-3"
        },
        textareaErrorClasses: {
          type: String,
          default: "font-size-big red-base placeholder-red-lighter-2 padding-normal border border-red-lighter-2 border-focus-red-base  bg-red-lighter-4 bg-focus-red-lighter-3"
        },
        labelClasses: {
          type: String,
          default: "font-size-big ink-base semi-bold margin-bottom-normal"
        },
        labelErrorClasses: {
          type: String,
          default: "font-size-big ink-base semi-bold margin-bottom-normal"
        },
        name: {
            type: String,
            required: true
        },
        label: {
            type: String,
            default: ''
        },
        value: {
            type: String,
            default: ''
        },
        maxlength: {
            type: String,
            default: '300'
        },
        placeholder: {
            type: String,
            default: 'Digite aqui...'
        },
        error: {
            type: String,
            default: ''
        }
    },
    computed: {
      textareaClassesToApply() {
        if(this.error) return this.textareaErrorClasses;
        else return this.textareaClasses;
      },
      labelClassesToApply() {
        if(this.error) return this.labelErrorClasses;
        else return this.labelClasses;
      }
    }
}
</script>

<style scoped lang="scss">
    label, label * {
        box-sizing: border-box;
    }
    label {
        display: block;
    }
    .textarea-wrapper {
        position: relative;
        width: 100%;
        display: inline-block; //to counter margin merging
    }
    textarea {
        height: 134px;
        border-radius: 5px;
        display: block;
        width: 100%;
        position: relative;
        z-index: 1;
        outline: none;
        resize: none;
    }
    span.icon-left {
        position: absolute;
        left: 1.3125rem;
        top: calc(0.8125rem + 0.05em);
        color: #8F8A9B;
        z-index: 2;
    }
    span.icon-right {
        position: absolute;
        top: calc(0.8125rem + 0.05em);
        right: 1.3125rem;
        color: #8F8A9B;
        z-index: 2;
    }
    textarea.has-icon-left {
        padding-left: calc(2.625rem + 0.8em);
    }
    textarea.has-icon-right {
        padding-right: calc(2.625rem + 0.8em);
    }
    span.textarea-error {
        display: block;
        text-align: left;
        line-height: 1;
    }
    label span.label {
        display: block;
        text-align: left;
    }
</style>

<docs>
    BTextarea
    ```js 
    <b-textarea label="Label comes here" />
    ```
</docs>
